#2011, Eulalie Sauthier, Master Thesis

pot <- function(input_data,colonne, seuil,dbt,fin, fin_j,fq) {
#permet de faire le graphe de la distribution des valeur extrêmes et de la distribution de poisson

nb_annes<-1; #nombre d'année de la fenêtre

pluies<-ts(input_data[,colonne], start = c(dbt, 1),end=c(fin, fin_j) ,frequency = fq) #série temporelle
seuil_variable<-seuil # définition du seuil
size_vec<-max(time(pluies))-min(time(pluies))
name<-paste(colnames(input_data)[colonne],seuil) #nom de fichier

out<-matrix(nrow= ceiling(size_vec),ncol= 6) #déclare l'output
pluies[is.na(pluies)]<-0 #met les NA à 0
input_data<-pluies 

j<-1;k<-1;i<-1;count<-0; #indices
temp<-numeric(1) #met à 0
temp<-input_data[1:12]
temp_2<-temp[which(temp > seuil_variable)] #garde les valeurs supérieures au seuil
o<-1;r<-12; #indice de la première ligne du vecteur original
out[1,3]<-length(temp_2)/(12)
out[1,2]<-length(temp_2) #occurences d'événements
out[1,1]<-1864 #date
out[i,4]<-o #indices
out[i,5]<-r
out[i,6]<-sum(temp_2) #somme des supérieurs au seuil
o<-13;r<-24
for(i in 2: (ceiling(size_vec)-2)){ #on garde les valeurs > seuil par années
	temp<-0
	temp_2<-0
	temp<-input_data[o:r]
	
	if(any(temp > seuil_variable)){
		temp_2<-temp[which(temp > seuil_variable)]
		out[i,1]<- dbt -1 +((i))
		out[i,2]<-length(temp_2)
		out[i,3]<-length(temp_2)/(12)
		out[i,4]<-o
		out[i,5]<-r
		out[i,6]<-sum(temp_2)
		
		o<-o+12;r<-r+12;
	
	}else{
		
	out[i,1]<-dbt-1+i
	out[i,2]<-0
	out[i,3]<-0
	out[i,4]<-o
	out[i,5]<-r
	out[i,6]<-0

	o<-o+12;r<-r+12;
	}
}

#####
#fin
#####
temp<-input_data[1765:1767]
temp_2<-0
if(any(temp > seuil_variable)){
temp_2<-temp[which(temp > seuil_variable)]
out[ceiling(size_vec),3]<-length(temp_2)/(12)
out[ceiling(size_vec),2]<-length(temp_2) #occurences d'événements
out[ceiling(size_vec),1]<-2011 #date
out[ceiling(size_vec),4]<-o
out[ceiling(size_vec),5]<-r
out[,6]<-sum(temp_2)
}else{
	out[ceiling(size_vec),1]<-2011
	out[ceiling(size_vec),2]<-0
	out[ceiling(size_vec),3]<-0
	out[ceiling(size_vec),4]<-o
	out[ceiling(size_vec),5]<-r
	out[ceiling(size_vec),6]<-0
	}

#####
#graphe avec probabilités
#####
lambda=mean(out[,2], na.rm = TRUE) #estimateur de poisson
z<-sort(out[,2]) #ordrer les valeurs
x<-seq(1,length(z)) / (length(z)+1) #vectur de probabilités
x_pois<-seq(1, length(z), length.out=40 )/(length(z)+1) #vecteur pour loi de poisson

pdf(paste("../Image/POT_",name,".pdf"))
plot(1-x,z,xlab="P(X<x)",ylab="Nombre de dépassements", main=paste("Distr Precipitations pour ",name))
lines(1-x_pois,qpois(x_pois,lambda), type="s",col="red")
legend("topright",c("Données empiriques","CDF Poisson"),pch=21, pt.bg="white", lty=1,col=c("black","red"))
dev.off()

}